/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2015-2017 Intel Corporation
 */
#ifndef TEST_DPAA2_DPDK_H_
#define TEST_DPAA2_DPDK_H_

#include <time.h>
#include <stdio.h>
#include <unistd.h>    
#include <rte_common.h>
//#include <rte_hexdump.h>
#include <rte_mbuf.h>
#include <rte_malloc.h>
#include <rte_memcpy.h>
//#include <rte_pause.h>
//#include <rte_bus_vdev.h>
#include <rte_security.h>      
#include <rte_crypto.h>
#include <rte_cryptodev.h>
#include <rte_eal.h>

#ifdef RTE_CRYPTO_SCHEDULER
#include <rte_cryptodev_scheduler.h>
#endif

#define FALSE                           0
#define TRUE                            1

#define NUM_MBUFS                       8191
#define MBUF_CACHE_SIZE                 256
#define MAX_NB_SESSIONS 4
#define MAX_NUM_OPS_DESCRIPTORS         4096
#define MAXIMUM_IV_LENGTH			16
        
#define BURST_NUM  8191

#define MBUF_DATAPAYLOAD_SIZE		4096
#define MBUF_SIZE			(sizeof(struct rte_mbuf) + \
                		RTE_PKTMBUF_HEADROOM + MBUF_DATAPAYLOAD_SIZE)


#define POOL_CACHE_SIZE      512

#define DEFAULT_NUM_XFORMS              2

#define IV_OFFSET		(sizeof(struct rte_crypto_op) + \
                        sizeof(struct rte_crypto_sym_op))

struct dpaa2_cryptodev_ctx {
    struct rte_mempool *mbuf_pool;
    struct rte_mempool *crypto_op_pool;
    struct rte_cryptodev_config conf;
    struct rte_cryptodev_qp_conf qp_conf;
    uint8_t dev_id;
};

struct dpaa2_bursts_ctx {
    uint8_t dev_id;
    struct rte_cryptodev_sym_session *session;    
    uint32_t enqueue_burst_num;
    uint32_t enqueue_len[BURST_NUM];      
    uint8_t *enqueue_buf[BURST_NUM];    
    uint8_t cipher_iv_len[BURST_NUM];    
    uint8_t *cipher_iv[BURST_NUM];
    struct rte_crypto_op *crypto_ops[BURST_NUM];
    struct rte_mbuf *mbufs[BURST_NUM];    
    uint8_t *rtembuf_obuf[BURST_NUM];    
    uint32_t actual_enqueue_burst_num;    
    uint32_t actual_dequeue_burst_num;
};


#endif /* TEST_CRYPTODEV_H_ */
